Index: tmp/org.txm.setups/nsis/Include/StrFunc.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/StrFunc.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/StrFunc.nsh	(revision 2956)
@@ -1,6 +1,6 @@
 /*
 o-----------------------------------------------------------------------------o
-|String Functions Header File 1.09                                            |
+|String Functions Header File 1.10                                            |
 (-----------------------------------------------------------------------------)
 | By deguix                                     / A Header file for NSIS 2.01 |
 | <cevo_deguix@yahoo.com.br>                   -------------------------------|
@@ -9,12 +9,10 @@
 o-----------------------------------------------------------------------------o
 */
 
-!verbose push
-!verbose 3
-!ifndef STRFUNC_VERBOSITY
-  !define STRFUNC_VERBOSITY 3
-!endif
-!define _STRFUNC_VERBOSITY ${STRFUNC_VERBOSITY}
+!verbose push 3
+!define /IfNDef STRFUNC_VERBOSITY 3
+!define /IfNDef _STRFUNC_VERBOSITY ${STRFUNC_VERBOSITY}
+!define /IfNDef _STRFUNC_CREDITVERBOSITY ${STRFUNC_VERBOSITY}
 !undef STRFUNC_VERBOSITY
 !verbose ${_STRFUNC_VERBOSITY}
 
@@ -22,19 +20,19 @@
 
 !ifndef STRFUNC
 
-  !define FALSE 0
-  !define TRUE 1
+  !define /IfNDef FALSE 0
+  !define /IfNDef TRUE 1
 
   ;Header File Identification
 
   !define STRFUNC `String Functions Header File`
-  !define STRFUNC_SHORT `StrFunc`
+  ;define STRFUNC_SHORT `StrFunc`
   !define STRFUNC_CREDITS `2004 Diego Pedroso`
 
   ;Header File Version
 
   !define STRFUNC_VERMAJ 1
-  !define STRFUNC_VERMED 09
+  !define STRFUNC_VERMED 10
  ;!define STRFUNC_VERMIN 0
  ;!define STRFUNC_VERBLD 0
 
@@ -47,154 +45,104 @@
 
   ;Header File Init Message
 
-  !verbose push
-  !verbose 4
+  !verbose push ${_STRFUNC_CREDITVERBOSITY}
   !echo `${STRFUNC_INITMSGPRE}NSIS ${STRFUNC} ${STRFUNC_VER} - Copyright ${STRFUNC_CREDITS}${STRFUNC_INITMSGPOST}`
   !verbose pop
 
-  ;Header File Function Init Message Prefix and Postfix
-
-  !define STRFUNC_FUNCMSGPRE ``
-  !define STRFUNC_FUNCMSGPOST ``
-  
   ;Header File Function Macros
 
+  !ifdef STRFUNC_USECALLARTIFICIALFUNCTION
+    !include Util.nsh
+  !endif
+
+  !define "Using:StrFunc" `!insertmacro STRFUNC_USING `
+  !macro STRFUNC_USING Name
+    !if "${STRFUNC_VERBOSITY}" > 4
+      !verbose push 4
+    !endif
+    !ifndef ${Name}_INCLUDED
+      ${${Name}} ; Invoke !insertmacro STRFUNC_MAKEFUNC
+    !endif
+    !if "${STRFUNC_VERBOSITY}" > 4
+      !verbose pop
+    !endif
+  !macroend
+
   !macro STRFUNC_FUNCLIST_INSERT Name
     !ifdef StrFunc_List
-      !define StrFunc_List2 `${StrFunc_List}`
-      !undef StrFunc_List
-      !define StrFunc_List `${StrFunc_List2}|${Name}`
-      !undef StrFunc_List2
+      !define /ReDef StrFunc_List `${StrFunc_List}|${Name}`
     !else
       !define StrFunc_List `${Name}`
     !endif
   !macroend
 
-  !macro STRFUNC_DEFFUNC Name
+  !macro STRFUNC_DEFFUNC Name List TypeList
     !insertmacro STRFUNC_FUNCLIST_INSERT ${Name}
-  
-    !define `${Name}` `!insertmacro FUNCTION_STRING_${Name}`
-    !define `Un${Name}` `!insertmacro FUNCTION_STRING_Un${Name}`
-  !macroend
-  
-  !macro STRFUNC_FUNC ShortName Credits
-    !verbose push
-    !verbose 4
-
-    !ifndef `Un${ShortName}`
-      !echo `${STRFUNC_FUNCMSGPRE}$ {Un${ShortName}} - Copyright ${Credits}${STRFUNC_FUNCMSGPOST}`
-      !verbose pop
-      !define `Un${ShortName}` `!insertmacro FUNCTION_STRING_Un${ShortName}_Call`
-      !define `Un${ShortName}_INCLUDED`
-      Function `un.${ShortName}`
+    !define `${Name}_List` `${List}`
+    !define `${Name}_TypeList` `${TypeList}`
+    !ifdef STRFUNC_USECALLARTIFICIALFUNCTION
+      !define `${Name}` `!insertmacro STRFUNC_CALL_${Name} "${un}" `
+      !define `Un${Name}` `!insertmacro STRFUNC_CALL_${Name} "${un}" `
     !else
-      !echo `${STRFUNC_FUNCMSGPRE}$ {${ShortName}} - Copyright ${Credits}${STRFUNC_FUNCMSGPOST}`
-      !verbose pop
-      !undef `${ShortName}`
-      !define `${ShortName}` `!insertmacro FUNCTION_STRING_${ShortName}_Call`
-      !define `${ShortName}_INCLUDED`
-      Function `${ShortName}`
+      !define `${Name}` `!insertmacro STRFUNC_MAKEFUNC ${Name} ""`
+      !define `Un${Name}` `!insertmacro STRFUNC_MAKEFUNC ${Name} Un`
     !endif
   !macroend
 
-  ;Function Names Startup Definition
-
-  !insertmacro STRFUNC_DEFFUNC StrCase
-  !define StrCase_List `ResultVar|String|Type`
-  !define StrCase_TypeList `Output|Text|Option  U L T S <>`
-  !macro `FUNCTION_STRING_UnStrCase`
-    !undef UnStrCase
-    !insertmacro FUNCTION_STRING_StrCase
+  !macro STRFUNC_MAKEFUNC basename un
+    !insertmacro STRFUNC_MAKEFUNC_${basename}
   !macroend
-  
-  !insertmacro STRFUNC_DEFFUNC StrClb
-  !define StrClb_List `ResultVar|String|Action`
-  !define StrClb_TypeList `Output|Text|Option  > < <>`
-  !macro `FUNCTION_STRING_UnStrClb`
-    !undef UnStrClb
-    !insertmacro FUNCTION_STRING_StrClb
-  !macroend
 
-  !insertmacro STRFUNC_DEFFUNC StrIOToNSIS
-  !define StrIOToNSIS_List `ResultVar|String`
-  !define StrIOToNSIS_TypeList `Output|Text`
-  !macro `FUNCTION_STRING_UnStrIOToNSIS`
-    !undef UnStrIOToNSIS
-    !insertmacro FUNCTION_STRING_StrIOToNSIS
+  !macro STRFUNC_BEGINFUNC basename un credits
+    !verbose push ${_STRFUNC_CREDITVERBOSITY}
+    !echo `${U+24}{${un}${basename}} - Copyright ${credits}`
+    !verbose pop
+    !define ${un}${basename}_INCLUDED
+    !ifndef STRFUNC_USECALLARTIFICIALFUNCTION
+      !define /ReDef ${un}${basename} `!insertmacro STRFUNC_CALL_${basename} "${un}" `
+      !if "${un}" != ""
+        Function un.${basename}
+      !else
+        Function ${basename}
+      !endif
+    !endif
   !macroend
-
-  !insertmacro STRFUNC_DEFFUNC StrLoc
-  !define StrLoc_List `ResultVar|String|StrToSearchFor|CounterDirection`
-  !define StrLoc_TypeList `Output|Text|Text|Option > <`
-  !macro `FUNCTION_STRING_UnStrLoc`
-    !undef UnStrLoc
-    !insertmacro FUNCTION_STRING_StrLoc
+  !macro STRFUNC_ENDFUNC
+    !ifndef STRFUNC_USECALLARTIFICIALFUNCTION
+      FunctionEnd
+    !endif
   !macroend
 
-  !insertmacro STRFUNC_DEFFUNC StrNSISToIO
-  !define StrNSISToIO_List `ResultVar|String`
-  !define StrNSISToIO_TypeList `Output|Text`
-  !macro `FUNCTION_STRING_UnStrNSISToIO`
-    !undef UnStrNSISToIO
-    !insertmacro FUNCTION_STRING_StrNSISToIO
+  !macro STRFUNC_CALL basename un
+    !ifdef STRFUNC_USECALLARTIFICIALFUNCTION
+      ${CallArtificialFunction} STRFUNC_MAKEFUNC_${basename}
+    !else
+      !if "${un}" != ""
+        Call un.${basename}
+      !else
+        Call ${basename}
+      !endif
+    !endif
   !macroend
 
-  !insertmacro STRFUNC_DEFFUNC StrRep
-  !define StrRep_List `ResultVar|String|StrToReplace|ReplacementString`
-  !define StrRep_TypeList `Output|Text|Text|Text`
-  !macro `FUNCTION_STRING_UnStrRep`
-    !undef UnStrRep
-    !insertmacro FUNCTION_STRING_StrRep
-  !macroend
 
-  !insertmacro STRFUNC_DEFFUNC StrSort
-  !define StrSort_List `ResultVar|String|LeftStr|CenterStr|RightStr|IncludeLeftStr|IncludeCenterStr|IncludeRightStr`
-  !define StrSort_TypeList `Output|Text|Text|Text|Text|Option 1 0|Option 1 0|Option 1 0`
-  !macro `FUNCTION_STRING_UnStrSort`
-    !undef UnStrSort
-    !insertmacro FUNCTION_STRING_StrSort
-  !macroend
+  ############################################################################  
+  # StrCase
+  !insertmacro STRFUNC_DEFFUNC StrCase `ResultVar|String|Type` `Output|Text|Option  U L T S <>`
 
-  !insertmacro STRFUNC_DEFFUNC StrStr
-  !define StrStr_List `ResultVar|String|StrToSearchFor`
-  !define StrStr_TypeList `Output|Text|Text`
-  !macro `FUNCTION_STRING_UnStrStr`
-    !undef UnStrStr
-    !insertmacro FUNCTION_STRING_StrStr
+  !macro STRFUNC_CALL_StrCase un ResultVar String Type
+    !verbose push ${STRFUNC_VERBOSITY}
+    !echo `${U+24}{${un}StrCase} "${ResultVar}" "${String}" "${Type}"`
+    !verbose 2
+    Push `${String}`
+    Push `${Type}`
+    !insertmacro STRFUNC_CALL StrCase "${un}"
+    Pop ${ResultVar}
+    !verbose pop
   !macroend
 
-  !insertmacro STRFUNC_DEFFUNC StrStrAdv
-  !define StrStrAdv_List `ResultVar|String|StrToSearchFor|SearchDirection|ResultStrDirection|DisplayStrToSearch|Loops|CaseSensitive`
-  !define StrStrAdv_TypeList `Output|Text|Text|Option > <|Option > <|Option 1 0|Text|Option 0 1`
-  !macro `FUNCTION_STRING_UnStrStrAdv`
-    !undef UnStrStrAdv
-    !insertmacro FUNCTION_STRING_StrStrAdv
-  !macroend
-
-  !insertmacro STRFUNC_DEFFUNC StrTok
-  !define StrTok_List `ResultVar|String|Separators|ResultPart|SkipEmptyParts`
-  !define StrTok_TypeList `Output|Text|Text|Mixed L|Option 1 0`
-  !macro `FUNCTION_STRING_UnStrTok`
-    !undef UnStrTok
-    !insertmacro FUNCTION_STRING_StrTok
-  !macroend
-
-  !insertmacro STRFUNC_DEFFUNC StrTrimNewLines
-  !define StrTrimNewLines_List `ResultVar|String`
-  !define StrTrimNewLines_TypeList `Output|Text`
-  !macro `FUNCTION_STRING_UnStrTrimNewLines`
-    !undef UnStrTrimNewLines
-    !insertmacro FUNCTION_STRING_StrTrimNewLines
-  !macroend
-
-  ;Function Codes for Install and Uninstall
-
-  # Function StrCase
-  ################
-
-  !macro FUNCTION_STRING_StrCase
-    !insertmacro STRFUNC_FUNC `StrCase` `2004 Diego Pedroso - Based on functions by Dave Laundon`
-
+  !macro STRFUNC_MAKEFUNC_StrCase
+    !insertmacro STRFUNC_BEGINFUNC ${basename} `${un}` `2004 Diego Pedroso - Based on functions by Dave Laundon`
     /*After this point:
       ------------------------------------------
        $0 = String (input)
@@ -285,7 +233,7 @@
           ; Else convert to lower case.
 
           ;Use "IsCharAlpha" for the job
-          System::Call "*(&t1 r7) i .r8"
+          System::Call "*(&t1 r7) p .r8"
           System::Call "*$8(&i1 .r7)"
           System::Free $8
           System::Call "user32::IsCharAlpha(i r7) i .r8"
@@ -325,7 +273,7 @@
           ; Switch all characters cases to their inverse case.
 
           ;Use "IsCharUpper" for the job
-          System::Call "*(&t1 r6) i .r8"
+          System::Call "*(&t1 r6) p .r8"
           System::Call "*$8(&i1 .r7)"
           System::Free $8
           System::Call "user32::IsCharUpper(i r7) i .r8"
@@ -365,13 +313,28 @@
       Pop $2
       Pop $1
       Exch $0
-    FunctionEnd
+    !insertmacro STRFUNC_ENDFUNC
 
   !macroend
 
-  !macro FUNCTION_STRING_StrClb
-    !insertmacro STRFUNC_FUNC `StrClb` `2004 Diego Pedroso - Based on functions by Nik Medved`
+  ############################################################################  
+  # StrClb
+  !insertmacro STRFUNC_DEFFUNC StrClb `ResultVar|String|Action` `Output|Text|Option  > < <>`
 
+  !macro STRFUNC_CALL_StrClb un ResultVar String Action
+    !verbose push ${STRFUNC_VERBOSITY}
+    !echo `${U+24}{${un}StrClb} "${ResultVar}" "${String}" "${Action}"`
+    !verbose 2
+    Push `${String}`
+    Push `${Action}`
+    !insertmacro STRFUNC_CALL StrClb "${un}"
+    Pop ${ResultVar}
+    !verbose pop
+  !macroend
+
+  !macro STRFUNC_MAKEFUNC_StrClb
+    !insertmacro STRFUNC_BEGINFUNC ${basename} `${un}` `2004 Diego Pedroso - Based on functions by Nik Medved`
+
     /*After this point:
       ------------------------------------------
        $0 = String (input)
@@ -395,7 +358,7 @@
       StrCpy $4 ""
 
       ;Open the clipboard to do the operations the user chose (kichik's fix)
-      System::Call 'user32::OpenClipboard(i $HWNDPARENT)'
+      System::Call 'user32::OpenClipboard(p $HWNDPARENT)'
 
       ${If} $1 == ">" ;Set
 
@@ -405,43 +368,44 @@
         ;Step 2: Allocate global heap
         StrLen $2 $0
         IntOp $2 $2 + 1
-        System::Call 'kernel32::GlobalAlloc(i 2, i r2) i.r2'
+        IntOp $2 $2 * ${NSIS_CHAR_SIZE}
+        System::Call 'kernel32::GlobalAlloc(i 2, i r2) p.r2'
 
         ;Step 3: Lock the handle
-        System::Call 'kernel32::GlobalLock(i r2) i.r3'
+        System::Call 'kernel32::GlobalLock(p r2) i.r3'
 
         ;Step 4: Copy the text to locked clipboard buffer
-        System::Call 'kernel32::lstrcpyA(i r3, t r0)'
+        System::Call 'kernel32::lstrcpy(p r3, t r0)'
 
         ;Step 5: Unlock the handle again
-        System::Call 'kernel32::GlobalUnlock(i r2)'
+        System::Call 'kernel32::GlobalUnlock(p r2)'
 
         ;Step 6: Set the information to the clipboard
-        System::Call 'user32::SetClipboardData(i 1, i r2)'
+        System::Call 'user32::SetClipboardData(i 1, p r2)'
 
         StrCpy $0 ""
 
       ${ElseIf} $1 == "<" ;Get
 
         ;Step 1: Get clipboard data
-        System::Call 'user32::GetClipboardData(i 1) i .r2'
+        System::Call 'user32::GetClipboardData(i 1) p .r2'
 
         ;Step 2: Lock and copy data (kichik's fix)
-        System::Call 'kernel32::GlobalLock(i r2) t .r0'
+        System::Call 'kernel32::GlobalLock(p r2) t .r0'
 
         ;Step 3: Unlock (kichik's fix)
-        System::Call 'kernel32::GlobalUnlock(i r2)'
+        System::Call 'kernel32::GlobalUnlock(p r2)'
 
       ${ElseIf} $1 == "<>" ;Swap
 
         ;Step 1: Get clipboard data
-        System::Call 'user32::GetClipboardData(i 1) i .r2'
+        System::Call 'user32::GetClipboardData(i 1) p .r2'
 
         ;Step 2: Lock and copy data (kichik's fix)
-        System::Call 'kernel32::GlobalLock(i r2) t .r4'
+        System::Call 'kernel32::GlobalLock(p r2) t .r4'
 
         ;Step 3: Unlock (kichik's fix)
-        System::Call 'kernel32::GlobalUnlock(i r2)'
+        System::Call 'kernel32::GlobalUnlock(p r2)'
 
         ;Step 4: Clear the clipboard
         System::Call 'user32::EmptyClipboard()'
@@ -449,19 +413,20 @@
         ;Step 5: Allocate global heap
         StrLen $2 $0
         IntOp $2 $2 + 1
-        System::Call 'kernel32::GlobalAlloc(i 2, i r2) i.r2'
+        IntOp $2 $2 * ${NSIS_CHAR_SIZE}
+        System::Call 'kernel32::GlobalAlloc(i 2, i r2) p.r2'
 
         ;Step 6: Lock the handle
-        System::Call 'kernel32::GlobalLock(i r2) i.r3'
+        System::Call 'kernel32::GlobalLock(p r2) i.r3'
 
         ;Step 7: Copy the text to locked clipboard buffer
-        System::Call 'kernel32::lstrcpyA(i r3, t r0)'
+        System::Call 'kernel32::lstrcpy(p r3, t r0)'
 
         ;Step 8: Unlock the handle again
-        System::Call 'kernel32::GlobalUnlock(i r2)'
+        System::Call 'kernel32::GlobalUnlock(p r2)'
 
         ;Step 9: Set the information to the clipboard
-        System::Call 'user32::SetClipboardData(i 1, i r2)'
+        System::Call 'user32::SetClipboardData(i 1, p r2)'
         
         StrCpy $0 $4
       ${Else} ;Clear
@@ -485,16 +450,27 @@
       Pop $2
       Pop $1
       Exch $0
-    FunctionEnd
+    !insertmacro STRFUNC_ENDFUNC
 
   !macroend
 
-  # Function StrIOToNSIS
-  ####################
+  ############################################################################  
+  # StrIOToNSIS
+  !insertmacro STRFUNC_DEFFUNC StrIOToNSIS `ResultVar|String` `Output|Text`
 
-  !macro FUNCTION_STRING_StrIOToNSIS
-    !insertmacro STRFUNC_FUNC `StrIOToNSIS` `2004 "bluenet" - Based on functions by Amir Szekely, Joost Verburg, Dave Laundon and Diego Pedroso`
+  !macro STRFUNC_CALL_StrIOToNSIS un ResultVar String
+    !verbose push ${STRFUNC_VERBOSITY}
+    !echo `${U+24}{${un}StrIOToNSIS} "${ResultVar}" "${String}"`
+    !verbose 2
+    Push `${String}`
+    !insertmacro STRFUNC_CALL StrIOToNSIS "${un}"
+    Pop ${ResultVar}
+    !verbose pop
+  !macroend
 
+  !macro STRFUNC_MAKEFUNC_StrIOToNSIS
+    !insertmacro STRFUNC_BEGINFUNC ${basename} `${un}` `2004 "bluenet" - Based on functions by Amir Szekely, Joost Verburg, Dave Laundon and Diego Pedroso`
+
     /*After this point:
       ------------------------------------------
        $R0 = String (input/output)
@@ -547,15 +523,28 @@
       Pop $R2
       Pop $R1
       Exch $R0
-    FunctionEnd
+    !insertmacro STRFUNC_ENDFUNC
   !macroend
 
-  # Function StrLoc
-  ###############
+  ############################################################################  
+  # StrLoc
+  !insertmacro STRFUNC_DEFFUNC StrLoc `ResultVar|String|StrToSearchFor|CounterDirection` `Output|Text|Text|Option > <`
 
-  !macro FUNCTION_STRING_StrLoc
-    !insertmacro STRFUNC_FUNC `StrLoc` `2004 Diego Pedroso - Based on functions by Ximon Eighteen`
+  !macro STRFUNC_CALL_StrLoc un ResultVar String StrToSearchFor OffsetDirection
+    !verbose push ${STRFUNC_VERBOSITY}
+    !echo `${U+24}{${un}StrLoc} "${ResultVar}" "${String}" "${StrToSearchFor}" "${OffsetDirection}"`
+    !verbose 2
+    Push `${String}`
+    Push `${StrToSearchFor}`
+    Push `${OffsetDirection}`
+    !insertmacro STRFUNC_CALL StrLoc "${un}"
+    Pop ${ResultVar}
+    !verbose pop
+  !macroend
 
+  !macro STRFUNC_MAKEFUNC_StrLoc
+    !insertmacro STRFUNC_BEGINFUNC ${basename} `${un}` `2004 Diego Pedroso - Based on functions by Ximon Eighteen`
+
     /*After this point:
       ------------------------------------------
        $R0 = OffsetDirection (input)
@@ -616,16 +605,27 @@
       Exch
       Pop $R1
       Exch $R0
-    FunctionEnd
+    !insertmacro STRFUNC_ENDFUNC
 
   !macroend
 
-  # Function StrNSISToIO
-  ####################
+  ############################################################################  
+  # StrNSISToIO
+  !insertmacro STRFUNC_DEFFUNC StrNSISToIO `ResultVar|String` `Output|Text`
 
-  !macro FUNCTION_STRING_StrNSISToIO
-    !insertmacro STRFUNC_FUNC `StrNSISToIO` `2004 "bluenet" - Based on functions by Amir Szekely, Joost Verburg, Dave Laundon and Diego Pedroso`
+  !macro STRFUNC_CALL_StrNSISToIO un ResultVar String
+    !verbose push ${STRFUNC_VERBOSITY}
+    !echo `${U+24}{${un}StrNSISToIO} "${ResultVar}" "${String}"`
+    !verbose 2
+    Push `${String}`
+    !insertmacro STRFUNC_CALL StrNSISToIO "${un}"
+    Pop ${ResultVar}
+    !verbose pop
+  !macroend
 
+  !macro STRFUNC_MAKEFUNC_StrNSISToIO
+    !insertmacro STRFUNC_BEGINFUNC ${basename} `${un}` `2004 "bluenet" - Based on functions by Amir Szekely, Joost Verburg, Dave Laundon and Diego Pedroso`
+
     /*After this point:
       ------------------------------------------
        $R0 = String (input/output)
@@ -679,15 +679,28 @@
       Pop $R2
       Pop $R1
       Exch $R0
-    FunctionEnd
+    !insertmacro STRFUNC_ENDFUNC
   !macroend
 
-  # Function StrRep
-  ###############
+  ############################################################################  
+  # StrRep
+  !insertmacro STRFUNC_DEFFUNC StrRep `ResultVar|String|StrToReplace|ReplacementString` `Output|Text|Text|Text`
 
-  !macro FUNCTION_STRING_StrRep
-    !insertmacro STRFUNC_FUNC `StrRep` `2004 Diego Pedroso - Based on functions by Hendri Adriaens`
+  !macro STRFUNC_CALL_StrRep un ResultVar String StringToReplace ReplacementString
+    !verbose push ${STRFUNC_VERBOSITY}
+    !echo `${U+24}{${un}StrRep} "${ResultVar}" "${String}" "${StringToReplace}" "${ReplacementString}"`
+    !verbose 2
+    Push `${String}`
+    Push `${StringToReplace}`
+    Push `${ReplacementString}`
+    !insertmacro STRFUNC_CALL StrRep "${un}"
+    Pop ${ResultVar}
+    !verbose pop
+  !macroend
 
+  !macro STRFUNC_MAKEFUNC_StrRep
+    !insertmacro STRFUNC_BEGINFUNC ${basename} `${un}` `2004 Diego Pedroso - Based on functions by Hendri Adriaens`
+
     /*After this point:
       ------------------------------------------
        $R0 = ReplacementString (input)
@@ -770,16 +783,33 @@
       Pop $R2
       Pop $R1
       Exch $R0
-    FunctionEnd
+    !insertmacro STRFUNC_ENDFUNC
 
   !macroend
 
-  # Function StrSort
-  ################
+  ############################################################################  
+  # StrSort
+  !insertmacro STRFUNC_DEFFUNC StrSort `ResultVar|String|CenterStr|LeftStr|RightStr|IncludeLeftStr|IncludeCenterStr|IncludeRightStr` `Output|Text|Text|Text|Text|Option 1 0|Option 1 0|Option 1 0`
 
-  !macro FUNCTION_STRING_StrSort
-    !insertmacro STRFUNC_FUNC `StrSort` `2004 Diego Pedroso - Based on functions by Stuart Welch`
+  !macro STRFUNC_CALL_StrSort un ResultVar String CenterStr LeftStr RightStr IncludeCenterStr IncludeLeftStr IncludeRightStr
+    !verbose push ${STRFUNC_VERBOSITY}
+    !echo `${U+24}{${un}StrSort} "${ResultVar}" "${String}" "${CenterStr}" "${LeftStr}" "${RightStr}" "${IncludeCenterStr}" "${IncludeLeftStr}" "${IncludeRightStr}"`
+    !verbose 2
+    Push `${String}`
+    Push `${CenterStr}`
+    Push `${LeftStr}`
+    Push `${RightStr}`
+    Push `${IncludeCenterStr}`
+    Push `${IncludeLeftStr}`
+    Push `${IncludeRightStr}`
+    !insertmacro STRFUNC_CALL StrSort "${un}"
+    Pop ${ResultVar}
+    !verbose pop
+  !macroend
 
+  !macro STRFUNC_MAKEFUNC_StrSort
+    !insertmacro STRFUNC_BEGINFUNC ${basename} `${un}` `2004 Diego Pedroso - Based on functions by Stuart Welch`
+
     /*After this point:
       ------------------------------------------
        $R0 = String (input)
@@ -977,16 +1007,28 @@
       Pop $R2
       Pop $R1
       Exch $R0
-    FunctionEnd
+    !insertmacro STRFUNC_ENDFUNC
 
   !macroend
-  
-  # Function StrStr
-  ###############
 
-  !macro FUNCTION_STRING_StrStr
-    !insertmacro STRFUNC_FUNC `StrStr` `2004 Diego Pedroso - Based on functions by Ximon Eighteen`
+  ############################################################################  
+  # StrStr
+  !insertmacro STRFUNC_DEFFUNC StrStr `ResultVar|String|StrToSearchFor` `Output|Text|Text`
 
+  !macro STRFUNC_CALL_StrStr un ResultVar String StrToSearchFor
+    !verbose push ${STRFUNC_VERBOSITY}
+    !echo `${U+24}{${un}StrStr} "${ResultVar}" "${String}" "${StrToSearchFor}"`
+    !verbose 2
+    Push `${String}`
+    Push `${StrToSearchFor}`
+    !insertmacro STRFUNC_CALL StrStr "${un}"
+    Pop ${ResultVar}
+    !verbose pop
+  !macroend
+
+  !macro STRFUNC_MAKEFUNC_StrStr
+    !insertmacro STRFUNC_BEGINFUNC ${basename} `${un}` `2004 Diego Pedroso - Based on functions by Ximon Eighteen`
+
     /*After this point:
       ------------------------------------------
        $R0 = StrToSearch (input)
@@ -1038,16 +1080,33 @@
       Pop $R2
       Pop $R1
       Exch $R0
-    FunctionEnd
+    !insertmacro STRFUNC_ENDFUNC
 
   !macroend
 
-  # Function StrStrAdv
-  ##################
+  ############################################################################  
+  # StrStrAdv
+  !insertmacro STRFUNC_DEFFUNC StrStrAdv `ResultVar|String|StrToSearchFor|SearchDirection|ResultStrDirection|DisplayStrToSearch|Loops|CaseSensitive` `Output|Text|Text|Option > <|Option > <|Option 1 0|Text|Option 0 1`
 
-  !macro FUNCTION_STRING_StrStrAdv
-    !insertmacro STRFUNC_FUNC `StrStrAdv` `2003-2004 Diego Pedroso`
+  !macro STRFUNC_CALL_StrStrAdv un ResultVar String StrToSearchFor SearchDirection ResultStrDirection DisplayStrToSearch Loops CaseSensitive
+    !verbose push ${STRFUNC_VERBOSITY}
+    !echo `${U+24}{${un}StrStrAdv} "${ResultVar}" "${String}" "${StrToSearchFor}" "${SearchDirection}" "${ResultStrDirection}" "${DisplayStrToSearch}" "${Loops}" "${CaseSensitive}"`
+    !verbose 2
+    Push `${String}`
+    Push `${StrToSearchFor}`
+    Push `${SearchDirection}`
+    Push `${ResultStrDirection}`
+    Push `${DisplayStrToSearch}`
+    Push `${Loops}`
+    Push `${CaseSensitive}`
+    !insertmacro STRFUNC_CALL StrStrAdv "${un}"
+    Pop ${ResultVar}
+    !verbose pop
+  !macroend
 
+  !macro STRFUNC_MAKEFUNC_StrStrAdv
+    !insertmacro STRFUNC_BEGINFUNC ${basename} `${un}` `2003-2004 Diego Pedroso`
+
     /*After this point:
       ------------------------------------------
        $0 = String (input)
@@ -1192,7 +1251,7 @@
         ; variable because it won't be used anymore
 
         ${If} $6 == 1
-          System::Call `kernel32::lstrcmpA(ts, ts) i.s` `$R3` `$1`
+          System::Call `kernel32::lstrcmp(ts, ts) i.s` `$R3` `$1`
           Pop $R3
           ${If} $R3 = 0
             StrCpy $R3 1 ; Continue
@@ -1301,15 +1360,29 @@
       Exch
       Pop $0
 
-    FunctionEnd
+    !insertmacro STRFUNC_ENDFUNC
 
   !macroend
 
-  # Function StrTok
-  ###############
+  ############################################################################  
+  # StrTok
+  !insertmacro STRFUNC_DEFFUNC StrTok `ResultVar|String|Separators|ResultPart|SkipEmptyParts` `Output|Text|Text|Mixed L|Option 1 0`
 
-  !macro FUNCTION_STRING_StrTok
-    !insertmacro STRFUNC_FUNC `StrTok` `2004 Diego Pedroso - Based on functions by "bigmac666"`
+  !macro STRFUNC_CALL_StrTok un ResultVar String Separators ResultPart SkipEmptyParts
+    !verbose push ${STRFUNC_VERBOSITY}
+    !echo `${U+24}{${un}StrTok} "${ResultVar}" "${String}" "${Separators}" "${ResultPart}" "${SkipEmptyParts}"`
+    !verbose 2
+    Push `${String}`
+    Push `${Separators}`
+    Push `${ResultPart}`
+    Push `${SkipEmptyParts}`
+    !insertmacro STRFUNC_CALL StrTok "${un}"
+    Pop ${ResultVar}
+    !verbose pop
+  !macroend
+
+  !macro STRFUNC_MAKEFUNC_StrTok
+    !insertmacro STRFUNC_BEGINFUNC ${basename} `${un}` `2004 Diego Pedroso - Based on functions by "bigmac666"`
     /*After this point:
       ------------------------------------------
        $0 = SkipEmptyParts (input)
@@ -1447,16 +1520,27 @@
       Pop $1
       Pop $2
       Exch $3
-    FunctionEnd
+    !insertmacro STRFUNC_ENDFUNC
 
   !macroend
 
-  # Function StrTrimNewLines
-  ########################
+  ############################################################################  
+  # StrTrimNewLines
+  !insertmacro STRFUNC_DEFFUNC StrTrimNewLines `ResultVar|String` `Output|Text`
 
-  !macro FUNCTION_STRING_StrTrimNewLines
-    !insertmacro STRFUNC_FUNC `StrTrimNewLines` `2004 Diego Pedroso - Based on functions by Ximon Eighteen`
+  !macro STRFUNC_CALL_StrTrimNewLines un ResultVar String
+    !verbose push ${STRFUNC_VERBOSITY}
+    !echo `${U+24}{${un}StrTrimNewLines} "${ResultVar}" "${String}"`
+    !verbose 2
+    Push `${String}`
+    !insertmacro STRFUNC_CALL StrTrimNewLines "${un}"
+    Pop ${ResultVar}
+    !verbose pop
+  !macroend
 
+  !macro STRFUNC_MAKEFUNC_StrTrimNewLines
+    !insertmacro STRFUNC_BEGINFUNC ${basename} `${un}` `2004 Diego Pedroso - Based on functions by Ximon Eighteen`
+
     /*After this point:
       ------------------------------------------
        $R0 = String (input)
